      subroutine genpart(i1,i2,i3,k)
c----------------------------------------------------------------------c
c Generates particles that couple to particles pl(i1) and pl(i2) and
c possibly pl(i3) through a vertex. 
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 13 October, 2006; based on routines genvvv.f and genvvvv.f
c                   modified 20-25 October, 2006
c                            May 2007 (basic change of output writing),
c                            22 May, 2007 (momenta signs modified in 
c                                          the output writing)
c                            28 May, 2007 (wrong call to ggggkk fixed)
c                            29 Sept., 2008 (nffb -> nffba, 
c                                       nbbb -> nbbba, nbbbb -> nbbbba)
c                            7 May, 2009 (bug in the declaration of 
c                                         output of vvsskk corrcted)
c                            11 May, 2009 (calls to routines of scalar
c                                          QED modified)
c                            16 June, 2009 (bug in call sssskk corrected)
c 26 May, 2010:
c array bound mismatches in the assignments for 'pl%ip' and v1,v2,v3
c corrected
c 27 Jan., 2011:
c anomalous Wtb coupling implemented
c 6 May, 2013:
c a bug in implementation of the anomalous Wtb coupling corrected
c----------------------------------------------------------------------c

      use mytypes
      use modpart
      use maxvals
      use vertices
      use extpart
      use intpart

      implicit none

      integer :: i1,i2,i3,i,j1,j2,j3,j4,k,k0,oif1,oif2,oif3,blad2,
     &           l,m,d1,d2,d3,nhiggs,npion,
     &           f1j,f1i,f1o,f1g,f1f,f1ct,f1n,f1e,
     &           f2j,f2i,f2o,f2g,f2f,f2ct,f2n,f2e,
     &           f3j,f3i,f3o,f3g,f3f,f3ct,f3n,f3e,
     &           plj,pli,plo,plg,plf,plct,pln,ple

      integer, allocatable :: v1(:),v2(:),v3(:),
     &                        f1ix(:),f2ix(:),f3ix(:),plix(:)

      character(80) ind,ind1,ind2,ind3,cl,ci1,ci2,ci3,ci4,
     &              cn1,cn2,cn3,cn
      character(160) cl1,cl2
      character(2) cp1,cp2,cp3

      type(particle) :: f1,f2,f3

c      open(13,file='colfs.txt',access='direct',form='formatted',
c     &                                                     recl=80)
c      open(18,file='calls.txt',access='direct',form='formatted',
c     &                                                     recl=160)
      open(16,file='partcls.tmp',access='direct',form='formatted',
     &                                                     recl=80)
      open(22,file='mdclsb.txt',
     &        access='direct',form='formatted',recl=160)

      read(16,1612,rec=i1) f1j,f1i,f1o,f1g,f1f,f1ct,f1n,f1e
      read(16,1612,rec=i2) f2j,f2i,f2o,f2g,f2f,f2ct,f2n,f2e

ckk>
c      write(*,*)'i1=',i1,f1j,f1i,f1o,f1g,f1f,f1ct,f1n,f1e
c      write(*,*)'i2=',i2,f2j,f2i,f2o,f2g,f2f,f2ct,f2n,f2e
ckk<

c 1612 format(6(i3),i24,i3)
 1612 format(i8,5(i3),i24,i3)

c      open(20,file='orders.tmp',access='direct',form='formatted',
c     &                                                     recl=80)

      allocate(f1ix(f1e),stat=blad2)
      allocate(f2ix(f2e),stat=blad2)

      read(20,1620,rec=i1) f1ix
      read(20,1620,rec=i2) f2ix
c      read(20,1620,rec=pl(i1)%k(0)) f1ix
c      read(20,1620,rec=pl(i2)%k(0)) f2ix

 1620 format(26(i3))

      k0=k

      f1=pl(i1)
      f2=pl(i2)

      if (i3 == 0) then

      if (i2 > 0) then

      if (f1j < 21) then            ! f1 is a fermion
       if (f2j < 21) then           ! f2 is a fermion too
        oif1=f1o*f1i*f1j
        oif2=f2o*f2i*f2j

        do i=1,nffba
         if ((oif1 == ffb(i,1) .and. oif2 == ffb(i,2))
     &       .or. (oif2 == ffb(i,1) .and. oif1 == ffb(i,2))) then

          k=k+1
          pl(k)%k(1)=i
c          pl(k)%k(0)=k
          plj=abs(ffb(i,3))
          plo=-1                ! an internal boson is always incoming 
                                ! to the vertex
          pli=ffb(i,3)/(plo*plj)
          if (plj == 24 .or. plj == 211) then
           plo=-plo           ! therefore a charged boson should be 
                              ! considered as 
                              ! the outgoing particle from the other vertex
          end if
          plct=cffb(i,3)
          pln=f1n*f2n
          ple=f1e+f2e
          call convert
          if (oif1 > 0) then
ckk>
           write(ind,'(i16)') k
           write(ind1,'(i16)') pln
           write(ci1,'(i16)') i1
           write(cn1,'(i16)') f1n
           write(ci2,'(i16)') i2
           write(cn2,'(i16)') f2n
           if (f1o > 0) then
            cp1='p'
           else
            cp1='-p'
           end if
           if (f2o > 0) then
            cp2='p'
           else
            cp2='-p'
           end if

           if (plf == 0) then
            cl='u'//trim(adjustl(ind))//'(1,'//trim(adjustl(ind1))//')'
            cl1='      call ffskk('
            cl2='      call ffsmd('
           else
            cl='u'//trim(adjustl(ind))//'(0:3,'//
     &                                        trim(adjustl(ind1))//')'
            cl1='      call ffvkk('
            cl2='      call ffvmd('
            if (iwtb == 1) then
             if (f1j == 5 .and. f2j == 6) then
              cl1='      call btwan('
              cl2='      call btwmd('//trim(cp1)//trim(adjustl(ci1))//
     &            '+'//trim(cp2)//trim(adjustl(ci2))//','
             else if (f1j == 6 .and. f2j == 5) then
              cl1='      call tbwan('
              cl2='      call tbwmd('//trim(cp1)//trim(adjustl(ci1))//
     &            '+'//trim(cp2)//trim(adjustl(ci2))//','
             end if
            end if
           end if
           write(21,'(a)',rec=k) cl
           cl1=trim(cl1)//'u'//trim(adjustl(ci1))//','//
     &        trim(adjustl(cn1))//','//trim(cp1)//trim(adjustl(ci1))//
     &        ','//'u'//trim(adjustl(ci2))//','//
     &        trim(adjustl(cn2))//','//trim(cp2)//trim(adjustl(ci2))//
     &        ','//'u'//trim(adjustl(ind))//','//trim(adjustl(ind1))//
     &        ','//'p'//trim(adjustl(ind))//','//trim(gffb(i))//','//
     &        trim(mffb(i,3))//','//trim(wffb(i,3))//')'

           write(18,'(a)',rec=k) trim(cl1)
ckk>
           write(31,'(a10,a10)',rec=k) trim(mffb(i,3)),trim(wffb(i,3))
ckk<
           write(ind1,'(i16)') i1
           write(ind2,'(i16)') i2

           allocate (plix(ple),stat=blad2)
           plix(:f1e)=f1ix
           plix(f1e+1:)=f2ix
c           call chckord
           write(20,1620,rec=k) plix

c           write(inh1,'(i16)') pl(i1)%k(0)
c           write(inh2,'(i16)') pl(i2)%k(0)

           write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gffb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),'

           pl(k)%k(2)=i1
           pl(k)%k(3)=i2
           pl(k)%k(4)=0
           call colinf(i1,i2,k)
c           end if
          else 
ckk>
           write(ind,'(i16)') k
           write(ind1,'(i16)') pln
           write(ci1,'(i16)') i2
           write(cn1,'(i16)') f2n
           write(ci2,'(i16)') i1
           write(cn2,'(i16)') f1n
           if (f2o > 0) then
            cp1='p'
           else
            cp1='-p'
           end if
           if (f1o > 0) then
            cp2='p'
           else
            cp2='-p'
           end if

           write(ind,'(i16)') k
           write(ind1,'(i16)') pln

           if (plf == 0) then
            cl='u'//trim(adjustl(ind))//'(1,'//trim(adjustl(ind1))//')'
            cl1='      call ffskk('
            cl2='      call ffsmd('
           else
            cl='u'//trim(adjustl(ind))//'(0:3,'//trim(adjustl(ind1))
     &                                                          //')'
            cl1='      call ffvkk('
            cl2='      call ffvmd('
            if (iwtb == 1) then
             if (f1j == 5 .and. f2j == 6) then
              cl1='      call tbwan('
              cl2='      call tbwmd('//trim(cp1)//trim(adjustl(ci1))//
     &            '+'//trim(cp2)//trim(adjustl(ci2))//','
             else if (f1j == 6 .and. f2j == 5) then
              cl1='      call btwan('
              cl2='      call btwmd('//trim(cp1)//trim(adjustl(ci1))//
     &            '+'//trim(cp2)//trim(adjustl(ci2))//','
             end if
            end if
           end if
           write(21,'(a)',rec=k) cl

           cl1=trim(cl1)//'u'//trim(adjustl(ci1))//','//
     &        trim(adjustl(cn1))//','//trim(cp1)//trim(adjustl(ci1))//
     &        ','//'u'//trim(adjustl(ci2))//','//
     &        trim(adjustl(cn2))//','//trim(cp2)//trim(adjustl(ci2))//
     &        ','//'u'//trim(adjustl(ind))//','//trim(adjustl(ind1))//
     &        ','//'p'//trim(adjustl(ind))//','//trim(gffb(i))//','//
     &        trim(mffb(i,3))//','//trim(wffb(i,3))//')'

           write(18,'(a)',rec=k) cl1
ckk>
           write(31,'(a10,a10)',rec=k) trim(mffb(i,3)),trim(wffb(i,3))
ckk<

           write(ind1,'(i16)') i2
           write(ind2,'(i16)') i1

           allocate (plix(ple),stat=blad2)
           plix(:f2e)=f2ix
           plix(f2e+1:)=f1ix
c           call chckord
c           write(inh1,'(i16)') pl(i2)%k(0)
c           write(inh2,'(i16)') pl(i1)%k(0)

           write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gffb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),'

           write(20,1620,rec=k) plix
           pl(k)%k(2)=i2
           pl(k)%k(3)=i1
           pl(k)%k(4)=0
           call colinf(i2,i1,k)
c           end if
          end if
c          call convert
         end if
        end do

       else if (f2j > 20) then   ! f2 is a boson
        oif1=f1o*f1i*f1j
        oif2=f2o*f2i*f2j
        do i=1,nffba
         if (oif1 == ffb(i,1) .and. oif2 == ffb(i,3)) then
          k=k+1
          pl(k)%k(1)=i
c          pl(k)%k(0)=k
          pli=f1i
          plo=f1o
          plj=abs(ffb(i,2))
          plct=cffb(i,2)
          pln=f1n*f2n
          ple=f1e+f2e
          call convert

ckk>
          write(ind,'(i16)') k
          write(ind1,'(i16)') pln
          write(ind2,'(i16)') pli
          write(ci1,'(i16)') i1
          write(cn1,'(i16)') f1n
          write(ci2,'(i16)') i2
          write(cn2,'(i16)') f2n

c          if (f2o == 0) then
c           if (f1o > 0) then
c            cp2='p'
c           else
c            cp2='-p'
c           end if
c          else
c           if (f1o*f2o < 0) then
c            cp2='-p'
c           else
c            cp2='p'
c           end if
c          end if

          cp1='p'
          if (i2 > nexpl) then
           if (f1o > 0) then
            cp2='p'
           else
            cp2='-p'
           end if
          else
           if (f1o*f2o > 0) then
            cp2='p'
           else
            cp2='-p'
           end if
          end if


c          write(18,3,rec=k) gffb(i),i1,i2,k
c 3        format('      call  fvkk(',a4,',',i6,',',i6,',',i8,')')
ckk>
           write(ind,'(i16)') k
           write(ind1,'(i16)') pln
           cl='u'//trim(adjustl(ind))//'(4,'//trim(adjustl(ind1))//')'
           write(21,'(a)',rec=k) cl

           if (f2f == 0) then
            cl1='      call fsfkk('
            cl2='      call fsfmd('
           else
            cl1='      call fvfkk('
            cl2='      call fvfmd('
            if (iwtb == 1) then
             if (f1j == 5 .and. f2j == 24) then
              cl1='      call fvfan('
              cl2='      call bwtmd('//trim(cp2)//trim(adjustl(ci2))
     &            //','
             else if (f1j == 6 .and. f2j == 24) then
              cl1='      call fvfan('
              cl2='      call twbmd('//trim(cp2)//trim(adjustl(ci2))
     &            //','
             end if
            end if
           end if
           cl1=trim(cl1)//'u'//trim(adjustl(ci1))//','//
     &        trim(adjustl(cn1))//','//trim(cp1)//trim(adjustl(ci1))//
     &        ','//'u'//trim(adjustl(ci2))//','//
     &        trim(adjustl(cn2))//','//trim(cp2)//trim(adjustl(ci2))//
     &        ','//'u'//trim(adjustl(ind))//','//trim(adjustl(ind1))//
     &        ','//'p'//trim(adjustl(ind))//','//trim(adjustl(ind2))//
     &        ','//trim(gffb(i))//','//
     &        trim(mffb(i,2))//','//trim(wffb(i,2))//')'

           write(18,'(a)',rec=k) cl1
ckk>
           write(31,'(a10,a10)',rec=k) trim(mffb(i,2)),trim(wffb(i,2))
ckk<

           write(ind1,'(i16)') i1
           write(ind2,'(i16)') i2

           allocate (plix(ple),stat=blad2)
           plix(:f1e)=f1ix
           plix(f1e+1:)=f2ix
c           call chckord
c           write(inh1,'(i16)') pl(i1)%k(0)
c           write(inh2,'(i16)') pl(i2)%k(0)

           write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gffb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),'

          write(20,1620,rec=k) plix
          pl(k)%k(2)=i1
          pl(k)%k(3)=i2
          pl(k)%k(4)=0
          call colinf(i1,i2,k)
         else if (oif1 == ffb(i,2) .and. oif2 == ffb(i,3)) then
          k=k+1
          pl(k)%k(1)=i
c          pl(k)%k(0)=k
          pli=f1i
          plo=f1o
          plj=abs(ffb(i,1))
          plct=cffb(i,1)
          pln=f1n*f2n
          ple=f1e+f2e
          call convert

c          write(18,5,rec=k) gffb(i),i2,i1,k
c 5        format('      call  vfkk(',a4,',',i6,',',i6,',',i8,')')
ckk>
          write(ind,'(i16)') k
          write(cn3,'(i16)') pln
          write(ci1,'(i16)') pli
          write(ind1,'(i16)') i2
          write(cn1,'(i16)') f2n
          write(ind2,'(i16)') i1
          write(cn2,'(i16)') f1n
c          if (f1o == 0) then
c           if (f2o > 0) then
c            cp1='p'
c           else
c            cp1='-p'
c           end if
c          else
c           if (f1o*f2o < 0) then
c            cp1='-p'
c           else
c            cp1='p'
c           end if
c          end if

          cp2='p'
          if (i2 > nexpl) then
           if (f1o > 0) then
            cp1='p'
           else
            cp1='-p'
           end if
          else
           if (f1o*f2o > 0) then
            cp1='p'
           else
            cp1='-p'
           end if
          end if

          if (f2f == 0) then
           cl1='      call sffkk('
           cl2='      call sffmd('
          else
           cl1='      call vffkk('
           cl2='      call vffmd('
           if (iwtb == 1) then
            if (f1j == 5 .and. f2j == 24) then
             cl1='      call vffan('
             cl2='      call wbtmd('//trim(cp1)//
     &             trim(adjustl(ind1))//','
            else if (f1j == 6 .and. f2j == 24) then
             cl1='      call vffan('
             cl2='      call wtbmd('//trim(cp1)//
     &             trim(adjustl(ind1))//','
            end if
           end if
          end if

          write(18,'(a)',rec=k) trim(cl1)//'u'//trim(adjustl(ind1))//','
     &             //trim(adjustl(cn1))//','//trim(cp1)//
     &             trim(adjustl(ind1))//','
     &             //'u'//trim(adjustl(ind2))//','
     &             //trim(adjustl(cn2))//','//trim(cp2)
     &             //trim(adjustl(ind2))//','
     &             //'u'//trim(adjustl(ind))//','
     &             //trim(adjustl(cn3))//',p'//trim(adjustl(ind))//','
     &             //trim(adjustl(ci1))//','//trim(gffb(i))//','//
     &             trim(mffb(i,1))//','//trim(wffb(i,1))//')'
ckk>
          write(31,'(a10,a10)',rec=k) trim(mffb(i,1)),trim(wffb(i,1))
ckk<

          allocate (plix(ple),stat=blad2)
          plix(:f2e)=f2ix
          plix(f2e+1:)=f1ix
c          call chckord
c          write(inh1,'(i16)') pl(i2)%k(0)
c          write(inh2,'(i16)') pl(i1)%k(0)

          write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gffb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),'

          write(ind,'(i16)') k
          write(ind1,'(i16)') pln
          cl='u'//trim(adjustl(ind))//'(4,'//trim(adjustl(ind1))//')'
          write(21,'(a)',rec=k) cl

          write(20,1620,rec=k) plix
          pl(k)%k(2)=i2
          pl(k)%k(3)=i1
          pl(k)%k(4)=0
          call colinf(i2,i1,k)
c          call convert
         end if
        end do
       end if
      else if (f1j > 20) then    ! f1 is a boson
       if (f2j < 21) then        ! f2 is a fermion
        oif1=f1o*f1i*f1j
        oif2=f2o*f2i*f2j
        do i=1,nffba
         if (oif1 == ffb(i,3) .and. oif2 == ffb(i,1)) then
          k=k+1
          pl(k)%k(1)=i
c          pl(k)%k(0)=k
          pli=f2i
          plo=f2o
          plj=abs(ffb(i,2))
          plct=cffb(i,2)
          pln=f1n*f2n
          ple=f1e+f2e
ckk>
          call convert
          write(ind,'(i16)') k
          write(ind1,'(i16)') pln
          write(ind2,'(i16)') pli
          write(ci1,'(i16)') i2
          write(cn1,'(i16)') f2n
          write(ci2,'(i16)') i1
          write(cn2,'(i16)') f1n
c          if (f2o == 0) then
c           if (f1o > 0) then
c            cp2='p'
c           else
c            cp2='-p'
c           end if
c          else
c           if (f1o*f2o < 0) then
c            cp2='-p'
c           else
c            cp2='p'
c           end if
c          end if

          cp1='p'
          if (i1 > nexpl) then
           if (f2o > 0) then
            cp2='p'
           else
            cp2='-p'
           end if
          else
           if (f1o*f2o > 0) then
            cp2='p'
           else
            cp2='-p'
           end if
          end if

c          open(unit=13,status='scratch',action='readwrite')
c          write(13,3) i2,gffb(i),i1,k
c          write(18,3,rec=k) gffb(i),i2,i1,k
ckk>
          write(ind,'(i16)') k
          write(ind1,'(i16)') pln
          cl='u'//trim(adjustl(ind))//'(4,'//trim(adjustl(ind1))//')'
          write(21,'(a)',rec=k) cl
          if (f1f == 0) then
           cl1='      call fsfkk('
           cl2='      call fsfmd('
          else
           cl1='      call fvfkk('
           cl2='      call fvfmd('
           if (iwtb == 1) then
c            if (f3j == 5 .and. f2j == 24) then 
            if (f2j == 5 .and. f1j == 24) then  ! 6 May, 2013
             cl1='      call fvfan('
             cl2='      call bwtmd('//trim(cp2)//trim(adjustl(ci2))//','
c            else if (f3j == 6 .and. f2j == 24) then
            else if (f2j == 6 .and. f1j == 24) then  ! 6 May, 2013
             cl1='      call fvfan('
             cl2='      call twbmd('//trim(cp2)//trim(adjustl(ci2))//','
            end if
           end if
          end if
          cl1=trim(cl1)//'u'//trim(adjustl(ci1))//','//
     &        trim(adjustl(cn1))//','//trim(cp1)//trim(adjustl(ci1))//
     &        ','//'u'//trim(adjustl(ci2))//','//
     &        trim(adjustl(cn2))//','//trim(cp2)//trim(adjustl(ci2))//
     &        ','//'u'//trim(adjustl(ind))//','//trim(adjustl(ind1))//
     &        ','//'p'//trim(adjustl(ind))//','//trim(adjustl(ind2))//
     &        ','//trim(gffb(i))//','//
     &        trim(mffb(i,2))//','//trim(wffb(i,2))//')'

          write(18,'(a)',rec=k) cl1
ckk>
          write(31,'(a10,a10)',rec=k) trim(mffb(i,2)),trim(wffb(i,2))
ckk<
          write(ind1,'(i16)') i2
          write(ind2,'(i16)') i1
          allocate (plix(ple),stat=blad2)
          plix(:f2e)=f2ix
          plix(f2e+1:)=f1ix
c          call chckord
c          write(inh1,'(i16)') pl(i2)%k(0)
c          write(inh2,'(i16)') pl(i1)%k(0)

          write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gffb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),'
ckk<
c          call printinf(check)
c          if (check) then
          write(20,1620,rec=k) plix
          pl(k)%k(2)=i2
          pl(k)%k(3)=i1
          pl(k)%k(4)=0
          call colinf(i2,i1,k)
c          call convert
c          end if
         else if (oif1 == ffb(i,3) .and. oif2 == ffb(i,2)) then
          k=k+1
          pl(k)%k(1)=i
c          pl(k)%k(0)=k
          pli=f2i
          plo=f2o
          plj=abs(ffb(i,1))
          plct=cffb(i,1)
          pln=f1n*f2n
          ple=f1e+f2e

          write(ind,'(i16)') k
          write(cn3,'(i16)') pln
          write(ci1,'(i16)') pli
          write(ind1,'(i16)') i1
          write(cn1,'(i16)') f1n
          write(ind2,'(i16)') i2
          write(cn2,'(i16)') f2n

          if (i1 > nexpl) then
           if (f2o > 0) then
            cp1='p'
           else
            cp1='-p'
           end if
          else
           if (f1o*f2o > 0) then
            cp1='p'
           else
            cp1='-p'
           end if
          end if
          cp2='p'

          if (f1f == 0) then
           cl1='      call sffkk('
           cl2='      call sffmd('
          else
           cl1='      call vffkk('
           cl2='      call vffmd('
           if (iwtb == 1) then
            if (f1j == 24 .and. f2j == 5) then
             cl1='      call vffan('
             cl2='      call wbtmd('//trim(cp1)//trim(adjustl(ind1))
     &         //','
            else if (f1j == 24 .and. f2j == 6) then
             cl1='      call vffan('
             cl2='      call wtbmd('//trim(cp1)//trim(adjustl(ind1))
     &         //','
            end if
           end if
          end if

          write(18,'(a)',rec=k) trim(cl1)//'u'//trim(adjustl(ind1))//','
     &             //trim(adjustl(cn1))//','//trim(cp1)//
     &             trim(adjustl(ind1))//','
     &             //'u'//trim(adjustl(ind2))//','
     &             //trim(adjustl(cn2))//','//trim(cp2)
     &             //trim(adjustl(ind2))//','
     &             //'u'//trim(adjustl(ind))//','
     &             //trim(adjustl(cn3))//',p'//trim(adjustl(ind))//','
     &             //trim(adjustl(ci1))//','//trim(gffb(i))//','//
     &             trim(mffb(i,1))//','//trim(wffb(i,1))//')'
ckk>
           write(31,'(a10,a10)',rec=k) trim(mffb(i,1)),trim(wffb(i,1))
ckk<
          allocate (plix(ple),stat=blad2)
          plix(:f1e)=f1ix
          plix(f1e+1:)=f2ix
c          call chckord
c          write(inh1,'(i16)') pl(i1)%k(0)
c          write(inh2,'(i16)') pl(i2)%k(0)

          write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gffb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),'

          write(ind,'(i16)') k
          write(ind1,'(i16)') pln
          cl='u'//trim(adjustl(ind))//'(4,'//trim(adjustl(ind1))//')'
          write(21,'(a)',rec=k) cl

          write(20,1620,rec=k) plix
          pl(k)%k(2)=i1
          pl(k)%k(3)=i2
          pl(k)%k(4)=0
          call colinf(i1,i2,k)
          call convert
         end if
        end do
       else if (f2j > 20) then         ! f2 is a boson too
        oif1=f1o*f1i*f1j
        oif2=f2o*f2i*f2j
        do i=1,nbbba
         do j1=1,3
          if (oif1 == bbb(i,j1)) then
           do j2=1,3
            if (j1 /= j2 .and. oif2 == bbb(i,j2)) then
             do j3=1,3
              if (j1 /= j3 .and. j2 /= j3) then
               k=k+1
               pl(k)%k(1)=i
c               pl(k)%k(0)=k
               plj=abs(bbb(i,j3))
               plo=-1              ! an internal boson is always incoming 
                                   ! to the vertex
               pli=bbb(i,j3)/(plo*plj)
c               if (oif1+oif2 /= 0) then
ckk>
c               if (plj == 24) then
               if (plj == 24 .or. plj == 211) then
ckk<
                plo=-plo          ! therefore a charged boson should be 
                                  ! considered as 
                                  ! the outgoing particle from the other vertex
               end if
               plct=cbbb(i,j3)
               pln=f1n*f2n
               ple=f1e+f2e
               call convert
               allocate (plix(ple),stat=blad2)
               plix(:f1e)=f1ix
               plix(f1e+1:)=f2ix
c               call chckord

               if (f1j /= 25 .and. f2j /= 25 .and. plj /= 25) then

                write(ind1,'(i16)') i1
                write(ind2,'(i16)') i2
                write(ind3,'(i16)') k
                write(ind,'(i16)') pln
                write(cn1,'(i16)') f1n
                write(cn2,'(i16)') f2n
                write(cn3,'(i16)') pln

                if (i1 > nexpl) then
                 cp1='-p'
                else
                 if (f1o < 0) then
                  cp1='p'
                 else
                  cp1='-p'
                 end if
                end if
                if (i2 > nexpl) then
                 cp2='-p'
                else
                 if (f2o < 0) then
                  cp2='p'
                 else
                  cp2='-p'
                 end if
                end if

                if (f1j == 211 .or. f2j == 211 .or. plj == 211) then
                 if (j1 == 1 .and. j2 == 2) then
                  cl1='      call ppakk(-1,'
                  cl2='      call ppamd(-1,'
                  cl='u'//trim(adjustl(ind3))//'(0:3,'//
     &                                        trim(adjustl(ind))//')'
                  write(21,'(a)',rec=k) cl
                 else if (j1 == 1 .and. j2 == 3) then
                  cl1='      call papkk(-1,'
                  cl2='      call papmd(-1,'
                  cl='u'//trim(adjustl(ind3))//'(1,'//
     &                                        trim(adjustl(ind))//')'
                  write(21,'(a)',rec=k) cl
                 else if (j1 == 2 .and. j2 == 1) then
                  cl1='      call ppakk(1,'
                  cl2='      call ppamd(1,'
                  cl='u'//trim(adjustl(ind3))//'(0:3,'//
     &                                        trim(adjustl(ind))//')'
                  write(21,'(a)',rec=k) cl
                 else if (j1 == 2 .and. j2 == 3) then
                  cl1='      call papkk(1,'
                  cl2='      call papmd(1,'
                  cl='u'//trim(adjustl(ind3))//'(1,'//
     &                                        trim(adjustl(ind))//')'
                  write(21,'(a)',rec=k) cl
                 else if (j1 == 3 .and. j2 == 1) then
                  cl1='      call appkk(-1,'
                  cl2='      call appmd(-1,'
                  cl='u'//trim(adjustl(ind3))//'(1,'//
     &                                        trim(adjustl(ind))//')'
                  write(21,'(a)',rec=k) cl
                 else if (j1 == 3 .and. j2 == 2) then
                  cl1='      call appkk(1,'
                  cl2='      call appmd(1,'
                  cl='u'//trim(adjustl(ind3))//'(1,'//
     &                                        trim(adjustl(ind))//')'
                  write(21,'(a)',rec=k) cl
                 end if
                 write(18,'(a)',rec=k) trim(cl1)//
     &             'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &              ','//trim(cp1)//trim(adjustl(ind1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ',p'//trim(adjustl(ind3))//','//trim(gbbb(i))//','//
     &              trim(mbbb(i,j3))//','//trim(wbbb(i,j3))//')'
ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbb(i,j3)),
     &                                       trim(wbbb(i,j3))
ckk<

                 write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gbbb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),'//trim(cp1)//trim(adjustl(ind1))//','//'u'//
     &              trim(adjustl(ind2))//'(:,h'//trim(adjustl(ind2))//
     &             '(h)),'//trim(cp2)//trim(adjustl(ind2))//','

                else
                 if (j1 == 1 .and. j2 == 2) then
                  cl1='      call vvvkk(1,'
                  cl2='      call vvvmd(1,'
                 else if (j1 == 1 .and. j2 == 3) then
                  cl1='      call vvvkk(2,'
                  cl2='      call vvvmd(2,'
                 else if (j1 == 2 .and. j2 == 1) then
                  cl1='      call vvvkk(3,'
                  cl2='      call vvvmd(3,'
                 else if (j1 == 2 .and. j2 == 3) then
                  cl1='      call vvvkk(4,'
                  cl2='      call vvvmd(4,'
                 else if (j1 == 3 .and. j2 == 1) then
                  cl1='      call vvvkk(5,'
                  cl2='      call vvvmd(5,'
                 else if (j1 == 3 .and. j2 == 2) then
                  cl1='      call vvvkk(6,'
                  cl2='      call vvvmd(6,'
                 end if

                 write(18,'(a)',rec=k) trim(cl1)//
     &             'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &              ','//trim(cp1)//trim(adjustl(ind1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ',p'//trim(adjustl(ind3))//','//trim(gbbb(i))//','//
     &              trim(mbbb(i,j3))//','//trim(wbbb(i,j3))//')'
ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbb(i,j3)),
     &                                       trim(wbbb(i,j3))
ckk<

                 write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gbbb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),'//trim(cp1)//trim(adjustl(ind1))//','//'u'//
     &              trim(adjustl(ind2))//'(:,h'//trim(adjustl(ind2))//
     &             '(h)),'//trim(cp2)//trim(adjustl(ind2))//','

                 write(ind,'(i16)') k
                 write(ind1,'(i16)') pln
                 cl='u'//trim(adjustl(ind))//'(0:3,'//
     &                                        trim(adjustl(ind1))//')'
                 write(21,'(a)',rec=k) cl
                end if
               else if (f1j == 25 .and. f2j == 25 .and. plj == 25) 
     &                                                          then

c                write(18,9,rec=k) gbbb(i),i1,i2,k
 9              format('      call hhhkk(',a4,',',i6,',',i6,',',i8,
     &                                                             ')')
ckk>
                write(ind1,'(i16)') i1
                write(ind2,'(i16)') i2
                write(ind3,'(i16)') k
                write(cn1,'(i16)') f1n
                write(cn2,'(i16)') f2n
                write(cn3,'(i16)') pln
c                write(inh1,'(i16)') pl(i1)%k(0)
c                write(inh2,'(i16)') pl(i2)%k(0)

c                if (f1o < 0) then
c                 cp1='p'
c                else
c                 cp1='-p'
c                end if
c                if (f2o < 0) then
c                 cp2='p'
c                else
c                 cp2='-p'
c                end if

                if (i1 > nexpl) then
                 cp1='-p'
                else
                 if (f1o < 0) then
                  cp1='p'
                 else
                  cp1='-p'
                 end if
                end if
                if (i2 > nexpl) then
                 cp2='-p'
                else
                 if (f2o < 0) then
                  cp2='p'
                 else
                  cp2='-p'
                 end if
                end if

                cl='u'//trim(adjustl(ind3))//'(1,'//
     &                                        trim(adjustl(cn3))//')'
                write(21,'(a)',rec=k) cl

                write(18,'(a)',rec=k) '      call ssskk('//
     &             'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &             ','//trim(cp1)//trim(adjustl(ind1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ',p'//trim(adjustl(ind3))//','//trim(gbbb(i))//','//
     &              trim(mbbb(i,j3))//','//trim(wbbb(i,j3))//')'
ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbb(i,j3)),
     &                                       trim(wbbb(i,j3))
ckk<

                write(22,'(a)',rec=k) '      call sssmd('//
     &              trim(gbbb(i))//',u'//trim(adjustl(ind1))
     &              //'(:,h'//trim(adjustl(ind1))//'(h)),u'//
     &              trim(adjustl(ind2))//'(:,h'//trim(adjustl(ind2))//
     &             '(h)),'


ckk<
               else
c                write(13,11) i1,gbbb(i),i2,k
c                write(18,11,rec=k) gbbb(i),i1,i2,k
 11             format('      call vvhkk(',a4,',',i6,',',i6,',',i8,
     &                                                             ')')
ckk>
                if (f1f == 0) then               ! Scalar is on the
                 cl2='      call svvmd('          ! 1st,
                 cl1='      call svvkk('
                 cl='(0:3,'
                else if (f2f == 0) then      
                 cl2='      call vsvmd('          ! 2nd, or
                 cl1='      call vsvkk('
                 cl='(0:3,'
                else
                 cl2='      call vvsmd('          ! 3rd place
                 cl1='      call vvskk('
                 cl='(1,'
                end if

                write(ind1,'(i16)') i1
                write(ind2,'(i16)') i2
                write(ind3,'(i16)') k
                write(cn1,'(i16)') f1n
                write(cn2,'(i16)') f2n
                write(cn3,'(i16)') pln
c                write(inh1,'(i16)') pl(i1)%k(0)
c                write(inh2,'(i16)') pl(i2)%k(0)

c                if (f1o < 0) then
c                 cp1='p'
c                else
c                 cp1='-p'
c                end if
c                if (f2o < 0) then
c                 cp2='p'
c                else
c                 cp2='-p'
c                end if

                if (i1 > nexpl) then
                 cp1='-p'
                else
                 if (f1o < 0) then
                  cp1='p'
                 else
                  cp1='-p'
                 end if
                end if
                if (i2 > nexpl) then
                 cp2='-p'
                else
                 if (f2o < 0) then
                  cp2='p'
                 else
                  cp2='-p'
                 end if
                end if

                write(18,'(a)',rec=k) trim(cl1)//
     &             'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &             ','//trim(cp1)//trim(adjustl(ind1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ',p'//trim(adjustl(ind3))//','//trim(gbbb(i))//','//
     &              trim(mbbb(i,j3))//','//trim(wbbb(i,j3))//')'
ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbb(i,j3)),
     &                                       trim(wbbb(i,j3))
ckk<

                write(22,'(a)',rec=k) trim(cl2)
     &              //trim(gbbb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),'
ckk<
                cl='u'//trim(adjustl(ind3))//trim(cl)//
     &                                        trim(adjustl(cn3))//')'
                write(21,'(a)',rec=k) trim(cl)

               end if
               write(20,1620,rec=k) plix
               pl(k)%k(2)=i1
               pl(k)%k(3)=i2
               pl(k)%k(4)=0
               call colinf(i1,i2,k)
c               call convert
c               end if
               exit
              end if
             end do
             exit
            end if
           end do
           exit
          end if
         end do
        end do
       else
        write(*,*)'genvvv.f: Wrong MC index of particle 2: ',f2j
       end if
      else
       write(*,*)'genvvv.f: Wrong MC index of particle 1: ',f1j
      end if

      deallocate(f1ix,f2ix,plix,stat=blad2)

      else ! i2 = 0 <=> i1 is an external particle

c      pl(i1)%k(0)=i1
      pl(i1)%k(1:)=0

      end if ! i2 > 0 

      else ! i3 /= 0

      read(16,1612,rec=i3) f3j,f3i,f3o,f3g,f3f,f3ct,f3n,f3e

      allocate(f3ix(f3e),stat=blad2)

      read(20,1620,rec=i3) f3ix
c      read(20,1620,rec=pl(i3)%k(0)) f3ix


      f3=pl(i3)

      if (f1j > 20 .and. f2j > 20 .and. f3j > 20) then


      oif1=f1o*f1i*f1j
      oif2=f2o*f2i*f2j
      oif3=f3o*f3i*f3j

      do i=1,nbbbba
       do j1=1,4
        if (oif1 == bbbb(i,j1)) then
         do j2=1,4
          if (j1 /= j2 .and. oif2 == bbbb(i,j2)) then
           do j3=1,4
            if (j1 /= j3 .and. j2 /= j3 .and. oif3 == bbbb(i,j3)) then
             do j4=1,4
              if (j1 /= j4 .and. j2 /= j4 .and. j3 /= j4 .and.
     &            j1 /= j2 .and. j1 /= j3 .and. j2 /= j3) then
               if (f1ct == 1) then
                k=k+1
                pl(k)%k(1)=i
c                pl(k)%k(0)=k
                plct=cbbbb(i,j4)
c                pl(k)%k(0)=k
                write(13,'(a)',rec=k) '1'
                plj=abs(bbbb(i,j4))
                plo=-1         ! an internal boson is always incoming 
                                   ! to the vertex
                pli=bbbb(i,j4)/(plo*plj)
ckk>
c                if (plj == 24) then
                if (plj == 24 .or. plj == 211) then
ckk<
                 plo=-plo   ! therefore a charged boson should be 
                            ! considered as 
                            ! the outgoing particle from the other vertex
                end if
                pln=f1n*f2n*f3n
                ple=f1e+f2e+f3e
                allocate (plix(ple),stat=blad2)
                plix(:f1e)=f1ix
                plix(f1e+1:f1e+f2e)=f2ix
                plix(f1e+f2e+1:)=f3ix
c                call chckord
                write(20,1620,rec=k) plix
                pl(k)%k(2)=i1
                pl(k)%k(3)=i2
                pl(k)%k(4)=i3
                call convert

ckk>
                nhiggs=0
                if (f1j == 25) nhiggs=nhiggs+1
                if (f2j == 25) nhiggs=nhiggs+1
                if (f3j == 25) nhiggs=nhiggs+1
                if (plj == 25) nhiggs=nhiggs+1
                npion=0
                if (f1j == 211) npion=npion+1
                if (f2j == 211) npion=npion+1
                if (f3j == 211) npion=npion+1
                if (plj == 211) npion=npion+1
                if (nhiggs == 0 .and. npion == 0) then
c                if (f1j /= 25 .and. f2j /= 25 .and. f3j /= 25
c     &             .and. plj /= 25) then
ckk<
                 write(ind1,'(i16)') i1
                 write(ind2,'(i16)') i2
                 write(ind3,'(i16)') i3
                 write(ind,'(i16)') k
                 write(ci1,'(i16)') j1
                 write(ci2,'(i16)') j2
                 write(ci3,'(i16)') j3
                 write(ci4,'(i16)') j4
                 write(cn1,'(i16)') f1n
                 write(cn2,'(i16)') f2n
                 write(cn3,'(i16)') f3n
                 write(cn,'(i16)') pln

                 if (i1 > nexpl) then
                  cp1='-p'
                 else
                  if (f1o < 0) then
                   cp1='p'
                  else
                   cp1='-p'
                  end if
                 end if
                 if (i2 > nexpl) then
                  cp2='-p'
                 else
                  if (f2o < 0) then
                   cp2='p'
                  else
                   cp2='-p'
                  end if
                 end if
                 if (i3 > nexpl) then
                  cp3='-p'
                 else
                  if (f3o < 0) then
                   cp3='p'
                  else
                   cp3='-p'
                  end if
                 end if

                 write(18,'(a)',rec=k) '      call vvvvkk('//
     &             'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &              ','//trim(cp1)//trim(adjustl(ind1))//
     &              ','//trim(adjustl(ci1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &              ','//trim(adjustl(ci2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ','//trim(cp3)//trim(adjustl(ind3))//
     &              ','//trim(adjustl(ci3))//
     &             ',u'//trim(adjustl(ind))//','//trim(adjustl(cn))//
     &             ',p'//trim(adjustl(ind))//','//trim(adjustl(ci4))
     &             //','//trim(gbbbb(i))//','//
     &              trim(mbbbb(i,j4))//','//trim(wbbbb(i,j4))//')'

ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbbb(i,j4)),
     &                                       trim(wbbbb(i,j4))
ckk<

                 write(22,'(a)',rec=k) '      call vvvvmd('
     &              //trim(gbbbb(i))
     &              //',u'//trim(adjustl(ind1))
     &              //'(:,h'//trim(adjustl(ind1))//'(h)),'
     &              //trim(adjustl(ci1))
     &              //',u'//trim(adjustl(ind2))
     &              //'(:,h'//trim(adjustl(ind2))//'(h)),'
     &              //trim(adjustl(ci2))
     &              //',u'//trim(adjustl(ind3))
     &              //'(:,h'//trim(adjustl(ind3))//'(h)),'
     &              //trim(adjustl(ci3))//','


                 write(ind,'(i16)') k
                 write(ind1,'(i16)') pln
                 cl='u'//trim(adjustl(ind))//'(0:3,'//
     &                                        trim(adjustl(ind1))//')'
                 write(21,'(a)',rec=k) cl
ckk>
c                else if (f1j == 25 .and. f2j == 25 .and. f3j == 25
c     &                                       .and. plj == 25) then
                else if (nhiggs == 4) then
ckk<
                 write(ind1,'(i16)') i1
                 write(ind2,'(i16)') i2
                 write(ind3,'(i16)') i3
                 write(ind,'(i16)') k
                 write(cn1,'(i16)') f1n
                 write(cn2,'(i16)') f2n
                 write(cn3,'(i16)') f3n
                 write(cn,'(i16)') pln

                 if (i1 > nexpl) then
                  cp1='-p'
                 else
                  if (f1o < 0) then
                   cp1='p'
                  else
                   cp1='-p'
                  end if
                 end if
                 if (i2 > nexpl) then
                  cp2='-p'
                 else
                  if (f2o < 0) then
                   cp2='p'
                  else
                   cp2='-p'
                  end if
                 end if
                 if (i3 > nexpl) then
                  cp3='-p'
                 else
                  if (f3o < 0) then
                   cp3='p'
                  else
                   cp3='-p'
                  end if
                 end if

                 write(18,'(a)',rec=k) '      call sssskk('//
     &             'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &             ','//trim(cp1)//trim(adjustl(ind1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ',p'//trim(adjustl(ind3))//
     &             ',u'//trim(adjustl(ind))//','//trim(adjustl(cn))//
     &             ',p'//trim(adjustl(ind))//','//trim(gbbbb(i))//','//
     &              trim(mbbbb(i,j4))//','//trim(wbbbb(i,j4))//')' ! 16 June,
c     &             ',p'//trim(adjustl(ind))//trim(gbbbb(i))//','//
c     &              trim(mbbb(i,j4))//','//trim(wbbb(i,j4))//')'  ! 2009
ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbbb(i,j4)), ! 16 June, 2009
     &                                       trim(wbbbb(i,j4))
c                 write(31,'(a10,a10)',rec=k) trim(mbbb(i,j4)),
c     &                                       trim(wbbb(i,j4))
ckk<

                 write(22,'(a)',rec=k) '      call ssssmd('//
     &              trim(gbbbb(i))//',u'//
     &              trim(adjustl(ind1))//'(:,h'//trim(adjustl(ind1))//
     &             '(h)),u'//trim(adjustl(ind2))//'(:,h'//
     &              trim(adjustl(ind2))//'(h)),u'//trim(adjustl(ind3))
     &              //'(:,h'//trim(adjustl(ind3))//'(h)),'

                 write(ind,'(i16)') k
                 write(ind1,'(i16)') pln

                 cl='u'//trim(adjustl(ind))//'(1,'//
     &                                        trim(adjustl(ind1))//')'
                 write(21,'(a)',rec=k) cl
ckk>
                else if (nhiggs == 2 .and. npion == 0 .or.
     &                   nhiggs == 0 .and. npion == 2) then
c                else
ckk<
                 write(ind,'(i16)') k
                 write(ind1,'(i16)') pln
                 if (f1f > 0 .and. f2f > 0) then
ckk>
c 7 May, 2009:
c                  cl='u'//trim(adjustl(ind))//'(0:3,'//
c     &                                        trim(adjustl(ind1))//')'
                  cl='u'//trim(adjustl(ind))//'(1,'//
     &                                        trim(adjustl(ind1))//')'
ckk<
                  cl1='      call vvssmd('
                  cl2='      call vvsskk('
                 else if (f1f > 0 .and. f3f > 0) then
                  cl='u'//trim(adjustl(ind))//'(1,'//
     &                                        trim(adjustl(ind1))//')'
                  cl1='      call vsvsmd('
                  cl2='      call vsvskk('
                 else if (f1f > 0 .and. plf > 0) then
                  cl='u'//trim(adjustl(ind))//'(0:3,'//
     &                                         trim(adjustl(ind1))//')'
                  cl1='      call vssvmd('
                  cl2='      call vssvkk('
                 else if (f2f > 0 .and. f3f > 0) then
                  cl='u'//trim(adjustl(ind))//'(1,'//
     &                                        trim(adjustl(ind1))//')'
                  cl1='      call svvsmd('
                  cl2='      call svvskk('
                 else if (f3f > 0 .and. plf > 0) then
                  cl='u'//trim(adjustl(ind))//'(0:3,'//
     &                                        trim(adjustl(ind1))//')'
                  cl1='      call ssvvmd('
                  cl2='      call ssvvkk('
                 else if (f2f > 0 .and. plf > 0) then
                  cl='u'//trim(adjustl(ind))//'(0:3,'//
     &                                        trim(adjustl(ind1))//')'
                  cl1='      call svsvmd('
                  cl2='      call svsvkk('
                 end if
                 write(21,'(a)',rec=k) cl
                 write(ind1,'(i16)') i1
                 write(ind2,'(i16)') i2
                 write(ind3,'(i16)') i3
                 write(ind,'(i16)') k
                 write(cn1,'(i16)') f1n
                 write(cn2,'(i16)') f2n
                 write(cn3,'(i16)') f3n
                 write(cn,'(i16)') pln

                 if (i1 > nexpl) then
                  cp1='-p'
                 else
                  if (f1o < 0) then
                   cp1='p'
                  else
                   cp1='-p'
                  end if
                 end if
                 if (i2 > nexpl) then
                  cp2='-p'
                 else
                  if (f2o < 0) then
                   cp2='p'
                  else
                   cp2='-p'
                  end if
                 end if
                 if (i3 > nexpl) then
                  cp3='-p'
                 else
                  if (f3o < 0) then
                   cp3='p'
                  else
                   cp3='-p'
                  end if
                 end if

                 write(18,'(a)',rec=k) trim(cl2)//
     &             'u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &             ','//trim(cp1)//trim(adjustl(ind1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ','//trim(cp3)//trim(adjustl(ind3))//
     &             ',u'//trim(adjustl(ind))//','//trim(adjustl(cn))//
     &             ',p'//trim(adjustl(ind))//','//trim(gbbbb(i))//','//
     &              trim(mbbbb(i,j4))//','//trim(wbbbb(i,j4))//')'
ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbbb(i,j4)),
     &                                       trim(wbbbb(i,j4))
ckk<

                 write(22,'(a)',rec=k) trim(cl1)
     &              //trim(gbbbb(i))
     &              //',u'//trim(adjustl(ind1))
     &              //'(:,h'//trim(adjustl(ind1))//'(h)),'
     &              //'u'//trim(adjustl(ind2))
     &              //'(:,h'//trim(adjustl(ind2))//'(h)),'
     &              //'u'//trim(adjustl(ind3))
     &              //'(:,h'//trim(adjustl(ind3))//'(h)),'
                end if

               else if (f1ct == 8) then
                l=0
                m=i
                do
                 l=l+1
                 m=m+1
                 if (l > 3) exit
                 k=k+1
                 pl(k)%k(1)=m
c                 pl(k)%k(0)=k
                 plct=f1ct
                 write(ind1,'(i16)') i1
                 write(ind2,'(i16)') i2
                 write(ind3,'(i16)') i3
                 write(ind,'(i16)') k
                 if (l == 1) then
                  write(13,100,rec=k) l,trim(adjustl(ind1)),
     &                                  trim(adjustl(ind2)),
     &                                  trim(adjustl(ind3)),
     &                                  trim(adjustl(ind))
 100              format('c(',i1,',i',a,',i',a,',i',a,',i',a,')')
                 else if (l == 2) then
                  write(13,100,rec=k) l,trim(adjustl(ind1)),
     &                                  trim(adjustl(ind3)),
     &                                  trim(adjustl(ind)),
     &                                  trim(adjustl(ind2))
                 else if (l == 3) then
                  write(13,100,rec=k) l,trim(adjustl(ind1)),
     &                                  trim(adjustl(ind)),
     &                                  trim(adjustl(ind2)),
     &                                  trim(adjustl(ind3))
                 else
                  write(*,*)'genpart.f: No such colour structure', l
                 end if

                 plj=abs(bbbb(i,j4))
                 plo=-1      ! an internal boson is always incoming 
                             ! to the vertex
                 pli=bbbb(i,j4)/(plo*plj)
ckk>
c                 if (plj == 24) then
                 if (plj == 24 .or. plj == 211) then
ckk<
                  plo=-plo   ! therefore a charged boson should be 
                              ! considered as the outgoing particle 
                              ! from the other vertex
                 end if
                 pln=f1n*f2n*f3n
                 ple=f1e+f2e+f3e
                 allocate (plix(ple),stat=blad2)
                 plix(:f1e)=f1ix
                 plix(f1e+1:f1e+f2e)=f2ix
                 plix(f1e+f2e+1:)=f3ix
c                 call chckord
                 write(20,1620,rec=k) plix
                 pl(k)%k(2)=i1
                 pl(k)%k(3)=i2
                 pl(k)%k(4)=i3
                 call convert
c                 write(13,13) l,gbbbb(i),i1,i2,i3,k
c                 write(18,13,rec=k) gbbbb(i),l,i1,i2,i3,k
 13              format('      call ggggkk(',a4,',',i1,',',i6,
     &                  ',',i6,',',i6,',',i6,')')
ckk>
                 write(ci1,'(i16)') l
                 write(ind1,'(i16)') i1
                 write(ind2,'(i16)') i2
                 write(ind3,'(i16)') i3
                 write(ind,'(i16)') k
                 write(cn1,'(i16)') f1n
                 write(cn2,'(i16)') f2n
                 write(cn3,'(i16)') f3n
                 write(cn,'(i16)') pln

                 if (i1 > nexpl) then
                  cp1='-p'
                 else
                  if (f1o < 0) then
                   cp1='p'
                  else
                   cp1='-p'
                  end if
                 end if
                 if (i2 > nexpl) then
                  cp2='-p'
                 else
                  if (f2o < 0) then
                   cp2='p'
                  else
                   cp2='-p'
                  end if
                 end if
                 if (i3 > nexpl) then
                  cp3='-p'
                 else
                  if (f3o < 0) then
                   cp3='p'
                  else
                   cp3='-p'
                  end if
                 end if

                 write(18,'(a)',rec=k) '      call ggggkk('//
     &             trim(adjustl(ci1))//
     &             ',u'//trim(adjustl(ind1))//','//trim(adjustl(cn1))//
     &              ','//trim(cp1)//trim(adjustl(ind1))//
     &             ',u'//trim(adjustl(ind2))//','//trim(adjustl(cn2))//
     &             ','//trim(cp2)//trim(adjustl(ind2))//
     &             ',u'//trim(adjustl(ind3))//','//trim(adjustl(cn3))//
     &             ','//trim(cp3)//trim(adjustl(ind3))//
     &             ',u'//trim(adjustl(ind))//','//trim(adjustl(cn))//
     &             ',p'//trim(adjustl(ind))//','//trim(gbbbb(i))//','//
     &              trim(mbbbb(i,j4))//','//trim(wbbbb(i,j4))//')'
ckk>
                 write(31,'(a10,a10)',rec=k) trim(mbbbb(i,j4)),
     &                                       trim(wbbbb(i,j4))
ckk<

                 write(22,'(a)',rec=k) '      call ggggmd('
     &              //trim(adjustl(ci1))//','//trim(gbbbb(i))
     &              //',u'//trim(adjustl(ind1))
     &              //'(:,h'//trim(adjustl(ind1))//'(h))'
     &              //',u'//trim(adjustl(ind2))
     &              //'(:,h'//trim(adjustl(ind2))//'(h))'
     &              //',u'//trim(adjustl(ind3))
     &              //'(:,h'//trim(adjustl(ind3))//'(h)),'

                 write(ind,'(i16)') k
                 write(ind1,'(i16)') pln
                 cl='u'//trim(adjustl(ind))//'(0:3,'//
     &                                        trim(adjustl(ind1))//')'
                 write(21,'(a)',rec=k) cl
ckk<
c                call convert
                end do
               else 
                write(*,*)'genpart.f: Quartic couplings do not ',
     &                    'involve such a colour state',plct
               end if
               exit
              end if
             end do
             exit
            end if
           end do
           exit
          end if
         end do
         exit
        end if
       end do
      end do

      end if ! only bosons

      deallocate(f1ix,f2ix,f3ix,plix,stat=blad2)

      end if ! i3 == 0

      do l=k0+1,k
       if (i1 > nexpl) then
        d1=size(pl(i1)%ip)+1
        allocate(v1(d1),stat=blad2)
        if (d1-1 > 0) then
         v1(1:d1-1)=pl(i1)%ip
        end if
        v1(d1)=i1
       else
        d1=0
       end if
       if (i2 > nexpl) then
        d2=size(pl(i2)%ip)+1
        allocate(v2(d2),stat=blad2)
        if (d2-1 > 0) then
         v2(1:d2-1)=pl(i2)%ip
        end if
        v2(d2)=i2
       else
        d2=0
       end if
       if (i3 > nexpl) then
        d3=size(pl(i3)%ip)+1
        allocate(v3(d3),stat=blad2)
        if (d3-1 > 0) then
         v3(1:d3-1)=pl(i3)%ip
        end if
        v3(d3)=i3
       else
        d3=0
       end if
       allocate(pl(l)%ip(d1+d2+d3),stat=blad2)
       if (d1 > 0) then
c        pl(l)%ip(1:d1-1)=v1
c        pl(l)%ip(d1)=i1
        pl(l)%ip(1:d1)=v1    ! 26 May, 2010  
       end if
       if (d2 > 0) then
c        pl(l)%ip(d1+1:d1+d2-1)=v2
c        pl(l)%ip(d1+d2)=i2
        pl(l)%ip(d1+1:d1+d2)=v2    ! 26 May, 2010  
       end if
       if (d3 > 0) then
c        pl(l)%ip(d1+d2+1:d1+d2+d3-1)=v3
c        pl(l)%ip(d1+d2+d3)=i3
        pl(l)%ip(d1+d2+1:d1+d2+d3)=v3    ! 26 May, 2010  
       end if
       deallocate(v1,v2,v3,stat=blad2)
      end do

c      close(13)
      close(16)
c      close(18)
c      close(20)
      close(22)

      contains

       subroutine convert

       integer :: icvrt

       do icvrt=1,ipmod
        if (plj == prtj(icvrt)) then
         plg=prtg(icvrt)
         plf=prtf(icvrt)
         exit
        end if
       end do

       pl(k)%ct=plct

       write(16,1612,rec=k) plj,pli,plo,plg,plf,plct,pln,ple
c 1612  format(6(i3),i24,i3)
 1612 format(i8,5(i3),i24,i3)

       end subroutine convert

c       subroutine convert

c       if (plj == 1) then
c        plg=1
c        plf=4
c       else if (plj == 2) then
c        plg=1
c        plf=3
c       else if (plj == 3) then
c        plg=2
c        plf=4
c       else if (plj == 4) then
c        plg=2
c        plf=3
c       else if (plj == 5) then
c        plg=3
c        plf=4
c       else if (plj == 6) then
c        plg=3
c        plf=3
c       else if (plj == 7) then
c        plg=4
c        plf=4
c       else if (plj == 8) then
c        plg=4
c        plf=3
c       else if (plj == 11) then
c        plg=1
c        plf=2
c       else if (plj == 12) then
c        plg=1
c        plf=1
c       else if (plj == 13) then
c        plg=2
c        plf=2
c       else if (plj == 14) then
c        plg=2
c        plf=1
c       else if (plj == 15) then
c        plg=3
c        plf=2
c       else if (plj == 16) then
c        plg=3
c        plf=1
c       else if (plj == 17) then
c        plg=4
c        plf=2
c       else if (plj == 18) then
c        plg=4
c        plf=1
c       else if (plj == 21) then
c        plg=0
c        plf=4
c       else if (plj == 22) then
c        plg=0
c        plf=1
c       else if (plj == 23) then
c        plg=0
c        plf=2
c       else if (plj == 24) then
c        plg=0
c        plf=3
c       else if (plj == 25) then
c        plg=0
c        plf=0
c       else if (plj == 211) then
c        plg=0
c        plf=0
c       end if
c
c       pl(k)%ct=plct
c
c       write(16,1612,rec=k) plj,pli,plo,plg,plf,plct,pln,ple
cc 1612  format(6(i3),i24,i3)
c 1612 format(i8,5(i3),i24,i3)
c
c       end subroutine convert

c       subroutine printinf(check)

c       logical :: check

c       rewind 13
c       read(13,'(a)') pl(k)%cl
c       close(13,status='delete')

c       check=.true.

c       do i=1,k0
c        if (index(pl(i)%cl,pl(l)%cl(1:index(pl(k)%cl,',',.true.))) > 0) 
c     &                                                             then
c         check=.false.
c         exit
c        end if
c        if (.not. check) exit
c       end do

c       end subroutine printinf

       subroutine colinf(p1,p2,p0)
c Store color information

       integer :: p1,p2,p0
       character(80) ind0,ind1,ind2

       if (plct == 1) then
        if (pl(p1)%ct == 1) then
         write(13,'(a)',rec=k) '1'
        else 
         write(ind1,'(i16)') p1
         write(ind2,'(i16)') p2
c         write(13,10,rec=k) p1,p2
c 10      format('d(i(',i6,'),i(',i6,'))')
         write(13,10,rec=k) trim(adjustl(ind1)),trim(adjustl(ind2))
 10      format('d(i',a,',i',a,')')
 11      format('d(j,i',a,')')
 12      format('d(i',a,',j)')
        end if
       else if (plct == 3) then
        if (pl(p1)%ct == 1) then
c         write(13,10,rec=k) p0,p2
         write(ind0,'(i16)') p0
         write(ind2,'(i16)') p2
         if (plo*pli*plj > 0) then
          write(13,10,rec=k) trim(adjustl(ind2)),trim(adjustl(ind0))
         else
          write(13,10,rec=k) trim(adjustl(ind0)),trim(adjustl(ind2))
         end if
        else if (pl(p1)%ct == 3) then
         if (pl(p2)%ct == 1) then
c          write(13,10,rec=k) p0,p1
          write(ind0,'(i16)') p0
          write(ind1,'(i16)') p1
          if (plo*pli*plj > 0) then
           write(13,10,rec=k) trim(adjustl(ind1)),trim(adjustl(ind0))
          else
           write(13,10,rec=k) trim(adjustl(ind0)),trim(adjustl(ind1))
          end if
         else if (pl(p2)%ct == 8) then
c          write(13,20,rec=k) p2,p1,p0
          write(ind1,'(i16)') p1
          write(ind2,'(i16)') p2
          write(ind0,'(i16)') p0
          write(13,20,rec=k) trim(adjustl(ind2)),trim(adjustl(ind1)),
     &                       trim(adjustl(ind0))
         end if
        else if (pl(p1)%ct == 8) then
c         write(13,20,rec=k) p1,p0,p2
         write(ind1,'(i16)') p1
         write(ind2,'(i16)') p2
         write(ind0,'(i16)') p0
         write(13,20,rec=k) trim(adjustl(ind1)),trim(adjustl(ind0)),
     &                      trim(adjustl(ind2))
c 20      format('t(i(',i6,'),i(',i6,'),i(',i6,'))')
 20      format('t(i',a,',i',a,',i',a,')')
        end if
       else if (plct == 8) then
        if (pl(p1)%ct == 3) then
c         write(13,20,rec=k) p0,p1,p2
         write(ind1,'(i16)') p1
         write(ind2,'(i16)') p2
         write(ind0,'(i16)') p0
         write(13,20,rec=k) trim(adjustl(ind0)),trim(adjustl(ind1)),
     &                      trim(adjustl(ind2))
        else if (pl(p1)%ct == 8) then
         if (j1 == 1 .and. j2 == 2) then
c          write(13,30,rec=k) p1,p2,p0
          write(ind1,'(i16)') p1
          write(ind2,'(i16)') p2
          write(ind0,'(i16)') p0
          write(13,30,rec=k) trim(adjustl(ind1)),trim(adjustl(ind2)),
     &                       trim(adjustl(ind0))
         else if (j1 == 1 .and. j2 == 3) then
c          write(13,30,rec=k) p1,p0,p2
          write(ind1,'(i16)') p1
          write(ind2,'(i16)') p2
          write(ind0,'(i16)') p0
          write(13,30,rec=k) trim(adjustl(ind1)),trim(adjustl(ind0)),
     &                       trim(adjustl(ind2))
         else if (j1 == 2 .and. j2 == 1) then
c          write(13,30,rec=k) p2,p1,p0
          write(ind1,'(i16)') p1
          write(ind2,'(i16)') p2
          write(ind0,'(i16)') p0
          write(13,30,rec=k) trim(adjustl(ind2)),trim(adjustl(ind1)),
     &                       trim(adjustl(ind0))
         else if (j1 == 2 .and. j2 == 3) then
c          write(13,30,rec=k) p0,p1,p2
          write(ind1,'(i16)') p1
          write(ind2,'(i16)') p2
          write(ind0,'(i16)') p0
          write(13,30,rec=k) trim(adjustl(ind0)),trim(adjustl(ind1)),
     &                       trim(adjustl(ind2))
         else if (j1 == 3 .and. j2 == 1) then
c          write(13,30,rec=k) p2,p0,p1
          write(ind1,'(i16)') p1
          write(ind2,'(i16)') p2
          write(ind0,'(i16)') p0
          write(13,30,rec=k) trim(adjustl(ind2)),trim(adjustl(ind0)),
     &                       trim(adjustl(ind1))
         else if (j1 == 3 .and. j2 == 2) then
c          write(13,30,rec=k) p0,p2,p1
          write(ind1,'(i16)') p1
          write(ind2,'(i16)') p2
          write(ind0,'(i16)') p0
          write(13,30,rec=k) trim(adjustl(ind0)),trim(adjustl(ind2)),
     &                       trim(adjustl(ind1))
         end if
c 30      format('icom*f(i(',i6,'),i(',i6,'),i(',i6,'))')
c 30      format('icom*f(i',a,',i',a,',i',a,')')
 30      format('f(i',a,',i',a,',i',a,')')
        else
         write(*,*)'genpart.f: Wrong color state (1)',pl(p2)%ct
         stop
        end if
       else
        write(*,*)'genpart.f: Wrong color state (2)',plct
        stop
       end if

       end subroutine colinf

c       subroutine chckord

c       integer :: iio,jjo,iorx,plox(nexpl)

c       do iio=iplord,1,-1
c        plox=0
c        iorx=0
c        read(20,'(26(i3))',rec=iio) plox
c        do jjo=1,ple
c         if (plox(jjo) == plix(jjo)) then
c          if (jjo == ple .and. plox(ple+1) == 0) then
c           iorx=iio
c          end if
c         else
c          exit
c         end if
c        end do
c        if (iorx > 0) then
c         pl(k)%k(0)=iorx
c         exit
c        end if
c       end do

c       if (iorx == 0) then
c        iplord=iplord+1
c        pl(k)%k(0)=iplord
c        write(20,'(26(i3))',rec=iplord) plix
c       end if

c       end subroutine chckord

      end subroutine genpart
