      module inprms

      use mathprms

      real(dp), parameter ::  
     &     mz=91.1882d0,  gamz=2.4952d0, ! Z mass and width
     &     mw=80.419d0,   !gamw=2.12d0,  ! W mass and width
     &     ialph0=137.03599911d0, ! an inverse of alpha in the Thomson limit
     &     gmu=1.16639d-5,        ! the Fermi coupling constant
     &     mh=125.d0              ! Higgs mass

c Photon and gluon masses and widths

      real(dp), parameter :: ma=zero, gama=zero,
     &                       mg=zero, gamg=zero

c Quark masses that will be changed to corresponding cteq6f values  if ihad > 0: 
      real(dp), parameter :: 
     &       mu0=5.d-3, md0=10.d-3, ms0=200.d-3, 
     &       mc0=1.3d0, mb0=4.4d0


c Fermion masses:

      real(dp), parameter :: 
     &       me=0.51099892d-3, mmu=105.658369d-3, mtau=1.77699d0,
     &       mt=172.5d0, mpi=139.57018d-3
c     &       alphas=0.1176d0 ! at mz

      real(dp) :: mu, md, ms, mc, mb,      
     &            alphas=0.118d0, ! at mz, the same as in cteq6f,
     &            x0pdf=1.d-6     ! min of x in cteq6f and mstw

c Fermion widths:

      real(dp), parameter :: 
     &       game=zero       , gammu=zero       , gamtau=zero,
     &       gamu=zero       , gamc=zero        , 
     &       gamd=zero       , gams=zero        , gamb=zero,
     &       gampi=zero
c     &       gampi=1.054571628d-25/2.6033d-8

      real(dp) :: gamt=0.d0, gamh=0.d0, gamw=2.12d0, gmtb
c      real(dp) :: gamt=0.d0, gamh=0.d0, gamw=0.d0

c No of colours:

      real(dp), parameter :: ncol=3.d0

c Conversion costant (pb*GeV^2):

      real(dp), parameter ::   convc=0.389379304d9

c EW mixing parameter:

      real(dp), parameter ::   sw2=1.d0-(mw/mz)**2,
     &   ialphw=pi/(sqrt2*sw2*gmu*mw**2), ! This is exactly the Gmu scheme
     &   ialpho=0.1d0                     ! Arbitrary choice

      real(dp) :: ralpw0

c Magnitudes of the CKM mixing parameters:

      real(dp), parameter ::   
     &          V_ud=0.97427d0,  V_us=0.22534d0,  V_ub=0.00351d0,
     &          V_cd=0.22520d0,  V_cs=0.97344d0,  V_cb=0.0412d0,
     &          V_td=0.00867d0,  V_ts=0.0404d0,   V_tb=0.999146d0

      end module inprms

