      subroutine kinkk2(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=8
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3,q4
      real(dp) :: sqsl1,sqsl2,sqsl3,sqsl4
      real(dp) :: sqsu1,sqsu2,sqsu3,sqsu4
      real(dp) :: sqs1,sqs2,sqs3,sqs4
      real(dp) :: ds1,ds2,ds3,ds4
      real(dp) :: s1,s2,s3,s4
      real(dp) :: dl1,dl2,dl3,dl4
 
      if (ikin <= nt43) then                                                    
       sqsl1=m(3)+m(6)                                                          
       sqsl2=m(4)+m(5)                                                          
       sqsl3=m(7)+m(8)                                                          
       sqsl4=sqsl2+sqsl3                                                        
       if (imom /= 1) then                                                      
        q1=p(:,3)+p(:,6)                                                        
        q2=p(:,4)+p(:,5)                                                        
        q3=p(:,7)+p(:,8)                                                        
        q4=q2+q3                                                                
       end if                                                                   
       if (ikin == 63) then                                                     
       sqsu1=ecm-sqsl4                                                          
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)                 
       sqsu4=ecm-sqs1                                                           
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)                 
       sqsu3=sqs4-sqsl2                                                         
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)                
       sqsu2=sqs4-sqs3                                                          
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)                
       end if                                                                   
       if (ikin == 64) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 65) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt44) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       if (ikin == 66) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt45) then
       sqsl1=m(7)+m(8)
       sqsl2=m(3)+m(6)
       sqsl3=m(4)+m(5)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,3)+p(:,6)
        q3=p(:,4)+p(:,5)
        q4=q2+q3
       end if
       if (ikin == 67) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 68) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 69) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mh,gamh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(7:8),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(9:10),p(:,4),p(:,5),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt49) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(8)
       sqsl3=m(4)+m(5)
       sqsl4=sqsl3+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,8)
        q3=p(:,4)+p(:,5)
        q4=q3+q2
       end if
       if (ikin == 70) then
       sqsu4=ecm-m(7)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(8),x(7:8),q1,p(:,8),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(9:10),p(:,4),p(:,5),dl3)
       call kinff(imom,sqs4,sqs3,sqs2,x(11:12),q3,q2,dl4)
       call kinff(imom,ecm,m(7),sqs4,x(13:14),p(:,7),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt50) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(8)
       sqsl4=sqsl1+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,8)
        q4=q1+q3
       end if
       if (ikin == 71) then
       sqsu4=ecm-m(7)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 72) then
       sqsu4=ecm-m(7)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,sqs1,sqs3,x(11:12),q1,q3,dl4)
       call kinff(imom,ecm,m(7),sqs4,x(13:14),p(:,7),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt51) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=m(4)+sqsl2
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=p(:,4)+q2
        q4=q3+p(:,5)
       end if
       if (ikin == 73) then
       sqsu4=ecm-sqsl1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(9:10),p(:,4),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt52) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+m(5)
       sqsl4=m(4)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=q2+p(:,5)
        q4=p(:,4)+q3
       end if
       if (ikin == 74) then
       sqsu4=ecm-sqsl1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(9:10),q2,p(:,5),dl3)
       call kinff(imom,sqs4,m(4),sqs3,x(11:12),p(:,4),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt53) then
       sqsl1=m(7)+m(8)
       sqsl2=sqsl1+m(6)
       sqsl3=m(3)+sqsl2
       sqsl4=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=q1+p(:,6)
        q3=p(:,3)+q2
        q4=p(:,4)+p(:,5)
       end if
       if (ikin == 75) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mt,gamt,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(7:8),q1,p(:,6),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(9:10),p(:,3),q2,dl3)
       call kinff(imom,sqs4,m(4),m(5),x(11:12),p(:,4),p(:,5),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt54) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+sqsl1
       sqsl3=m(4)+m(5)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+q1
        q3=p(:,4)+p(:,5)
        q4=q2+q3
       end if
       if (ikin == 76) then
       sqsu4=ecm-m(8)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 77) then
       sqsu4=ecm-m(8)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,m(4),m(5),x(9:10),p(:,4),p(:,5),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,m(8),sqs4,x(13:14),p(:,8),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt55) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(8)
       sqsl3=m(7)+sqsl2
       sqsl4=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,8)
        q3=p(:,7)+q2
        q4=p(:,4)+p(:,5)
       end if
       if (ikin == 78) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(8),x(7:8),q1,p(:,8),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,m(4),m(5),x(11:12),p(:,4),p(:,5),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt56) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,4)+p(:,5)
       end if
       if (ikin == 79) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 80) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 81) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(4),m(5),x(11:12),p(:,4),p(:,5),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt57) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,4)+p(:,5)
       end if
       if (ikin == 82) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 83) then
       sqsu4=ecm-sqsl3
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=ecm-sqs4
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(4),m(5),x(11:12),p(:,4),p(:,5),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt58) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+sqsl1
       sqsl3=m(4)+m(5)
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+q1
        q3=p(:,4)+p(:,5)
        q4=q3+p(:,8)
       end if
       if (ikin == 84) then
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,mmu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 85) then
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,mmu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,m(4),m(5),x(9:10),p(:,4),p(:,5),dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt59) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+sqsl1
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+q1
       end if
       if (ikin == 86) then
       sqsu4=ecm-m(8)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,sqs1,x(11:12),q3,q1,dl4)
       call kinff(imom,ecm,m(8),sqs4,x(13:14),p(:,8),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt60) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(8)
       sqsl4=m(7)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,8)
        q4=p(:,7)+q3
       end if
       if (ikin == 87) then
       sqsu4=ecm-sqsl1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(7),sqs3,x(11:12),p(:,7),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt61) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(7)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,7)+p(:,8)
        q4=q2+q3
       end if
       if (ikin == 88) then
       sqsu4=ecm-sqsl1
       call mapbkk(imom,x(4),q4,mh,gamh,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 89) then
       sqsu4=ecm-sqsl1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt62) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(8)
       sqsl3=m(4)+m(5)
       sqsl4=m(7)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,8)
        q3=p(:,4)+p(:,5)
        q4=p(:,7)+q3
       end if
       if (ikin == 90) then
       sqsu4=ecm-sqsl2
       call mapbkk(imom,x(4),q4,zero,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs4
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(8),x(7:8),q1,p(:,8),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(9:10),p(:,4),p(:,5),dl3)
       call kinff(imom,sqs4,m(7),sqs3,x(11:12),p(:,7),q3,dl4)
       call kinff(imom,ecm,sqs4,sqs2,x(13:14),q4,q2,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt63) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       if (ikin == 91) then
       sqsu4=ecm-sqsl1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapbkk(imom,x(1),q1,mh,gamh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt64) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(7)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,7)+p(:,8)
        q4=q2+q3
       end if
       if (ikin == 92) then
       sqsu4=ecm-sqsl1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 93) then
       sqsu4=ecm-sqsl1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=ecm-sqs4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt70) then
       sqsl1=m(4)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+m(6)
       sqsl4=sqsl1+sqsl3
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q2+p(:,6)
        q4=q1+q3
       end if
       if (ikin == 94) then
       sqsu4=ecm-m(3)
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl1
       call mapbkk(imom,x(3),q3,mt,gamt,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs4-sqs3
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(5:6),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(9:10),q2,p(:,6),dl3)
       call kinff(imom,sqs4,sqs1,sqs3,x(11:12),q1,q3,dl4)
       call kinff(imom,ecm,m(3),sqs4,x(13:14),p(:,3),q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,6))
       end if
      end if
 
      end
